import java.awt.Color;
import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
 
/**
 * Write a description of class GreenPark here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class GreenPark extends World
{

    private boolean bossLevelActive = false;
    private boolean gameStarted = false;
    private boolean isBerriesActive = false;
    private int remainingBerriesTimer;
    
    private GreenfootImage hawk1;
    private GreenfootImage hawk2;
    private GreenfootImage owl1;
    private GreenfootImage owl2;
    private GreenfootImage squirrel1;
    private GreenfootImage squirrel2;
    private GreenfootImage squirrel3;
    private GreenfootImage squirrel4;
    private GreenfootImage squirrel5;
    private GreenfootImage squirrel6;


    private int currentScreen;

    private static int northExit;
    private static int southExit;
    private static int eastExit;
    private static int westExit;
    
    private int[] exits = new int[4];
    /**
     * Constructor for objects of class SquirrelWorld.
     * 
     */
    public GreenPark()
    {
        super(800, 600, 1); 
        currentScreen = 0;
        setPaintOrder(Hawk.class,Owl.class,OwlTree.class,Tree.class,Squirrel.class);
        
        getBackground().setColor(Color.RED);
        hawk1 = new GreenfootImage("hawk1.png");
        hawk2 = new GreenfootImage("hawk2.png");
        owl1 = new GreenfootImage("owl1.png");
        owl2 = new GreenfootImage("owl2.png");
        squirrel1 = new GreenfootImage("squirrel-a.png");
        squirrel2 = new GreenfootImage("squirrel-b.png");
        squirrel3 = new GreenfootImage("squirrel-c.png");
        squirrel4 = new GreenfootImage("squirrel-d.png");
        squirrel5 = new GreenfootImage("ultimate-a.png");
        squirrel6 = new GreenfootImage("ultimate-b.png");        
    }
    
    public GreenPark(int whichScreen)
    {
        super(800,600,1);
        setScreen(whichScreen);
        
    }

    /**
     * started - this method is run when you hit the run button. it checks to see if the game has been started previously,
     *           it not, it will run a script and then update it's condition so it wont happen again if the player
     *           pauses the game with the run button.
     */
    public void started()
    {
        if (!gameStarted)
        {
            prepare();
            gameStarted = true;
        }
    }
    /**
     * Must be run only once, once the game has started. Creates the squirrel and sets the initial stage.
     */
    private void prepare()
    {
        setScreen(currentScreen);
        addObject(new Squirrel(), 300, 200);
    }

    public void clearWorld()
    {
        removeObjects(getObjects(Trunk.class));
        removeObjects(getObjects(NorthExit.class));
        removeObjects(getObjects(SouthExit.class));
        removeObjects(getObjects(EastExit.class));
        removeObjects(getObjects(WestExit.class));        
        removeObjects(getObjects(OwlTree.class));
        removeObjects(getObjects(Owl.class));
        removeObjects(getObjects(Leaf.class));
        removeObjects(getObjects(Hawk.class));
        removeObjects(getObjects(PathBlockHoriz.class));
        removeObjects(getObjects(PathBlockVert.class));
        
    }
    public void setScreen(int whichScreen)
    {
        clearWorld();

        loadRoom(whichScreen);
        loadExits();
        buildBackground();
        
    }

    public void loadExits()
    {
        if (exits[0] != -1)
        {
            addObject (new NorthExit(exits[0]), getWidth() / 2, 5);
        }
        if (exits[1] != -1)
        {
            addObject (new SouthExit(exits[1]), getWidth() / 2, getHeight() - 5);
        }  
        if (exits[2] != -1)
        {
            addObject (new EastExit(exits[2]), getWidth() - 5, getHeight() / 2);
        }
        if (exits[3] != -1)
        {
            addObject (new WestExit(exits[3]), 5, getHeight() / 2);
        }
    }
    public void loadRoom(int roomNumber)
    {
        switch (roomNumber) 
        {
            case 0: exits[0] = 2; exits[1] = 3; exits[2] = 1; exits[3] = 4;
                    addObject(new OwlTree(), 50, 50);
                    addObject(new Trunk(),50, 50 + 26);
                    
                    break;

            case 1: exits[0] = -1; exits[1] = -1; exits[2] = -1; exits[3] = 0;
                    addObject(new OwlTree(), 500, 50);
                    addObject(new Trunk(),500,50+ 26);
                    break;

            case 2: exits[0] = -1; exits[1] = 0; exits[2] = -1; exits[3] = -1;
                    addObject(new OwlTree(), 50, 500);
                    addObject(new Trunk(),50,500+ 26);
                    break;

            case 3: exits[0] = 0; exits[1] = -1; exits[2] = -1; exits[3] = -1;
                    addObject(new OwlTree(), 500, 500);
                    addObject(new Trunk(),500,500+ 26);
                    break;

            case 4: exits[0] = -1; exits[1] = -1; exits[2] = 0; exits[3] = -1;
                    addObject(new OwlTree(), 50, 50);
                    addObject(new Trunk(),50,50+ 26);
                    addObject(new OwlTree(), 500, 500);
                    addObject(new Trunk(),500,500+ 26);                    
                    break;
        }        
    }
    public void getExits()
    {
        for (int i = 0; i < exits.length; i++)
        {
            System.out.println(exits[i]);
        }
    }
    public void getRoom()
    {
        System.out.println("Current screen:" + currentScreen);
    }
    public void buildBackground()
    {
        setBackground("ground-01.png");
        if (exits[0] != -1)
        {
            addObject(new PathBlockVert(), getWidth() / 2, 18);
        }
        if (exits[1] != -1)
        {
            addObject(new PathBlockVert(),getWidth() / 2, getHeight());
        }
        if (exits[2] != -1)
        {
            addObject(new PathBlockHoriz(),getWidth(), getHeight() / 2);
        }
        if (exits[3] != -1)
        {
            addObject(new PathBlockHoriz(),15, getHeight() / 2);
        }        

    }
}