import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Squirrel here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Squirrel extends Mover
{
    private GreenfootImage image1;
    private GreenfootImage image2;
    private GreenfootImage image3;
    private GreenfootImage image4;
    

    private static boolean invincible = false;

    private final int STUNTIMER = 30;
    private final int INVINCIBLETIMER = 50;
    private final int MAXHP = 3;
    
    private static int hitsLeft;
    private int speed = 10;
    private int stunTimeLeft = STUNTIMER;
    private int invincibleTimeLeft = INVINCIBLETIMER;
    private int leafSoundCycle; 
    private int animateCounter;
    private int animateDelay;

    private boolean activateUltimate = false;
    private boolean ultimateActive = false;
    private boolean stunned = false;
    private GreenPark myWorld;
    /**
     * Act - do whatever the Bug wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */

    public Squirrel()
    {
        image1 = new GreenfootImage("squirrel-a.png");
        image2 = new GreenfootImage("squirrel-b.png");
        image3 = new GreenfootImage("squirrel-c.png");
        image4 = new GreenfootImage("squirrel-d.png");
        
        hitsLeft = MAXHP;
        leafSoundCycle = 1;
  
    }   
    public void act() 
    {
        isDead();
        //boundaries();
        checkKeyPress();
        lookForStuff();
        if (stunned)
        {
            stunTimer();        
        }
        if (!invincible)
        {
            animate();
        } else
        {
            invincibleTimer();
            invincibleAnimation();
        }
    }    
    /**
     * Check if a control key has been pressed and react.
     * 
     */
    public void checkKeyPress() {
        if (Greenfoot.isKeyDown("right"))
        {
            setRotation(0);
            move(5 + speed);
        }
        if (Greenfoot.isKeyDown("up"))
        {
            setRotation(270);
            move(5 + speed);
        }
        if (Greenfoot.isKeyDown("down"))
        {
            setRotation(90);
            move(5 + speed);
        }
        if (Greenfoot.isKeyDown("left"))
        {
            setRotation(180);
            move(5 + speed);
        }
    }
    /**
     * Contains code for what to look for, and what to do with i
     * 
     */
    public void lookForStuff()
    {
        myWorld = (GreenPark) getWorld();
        if (canSee(NorthExit.class) && NorthExit.whichExit() >= 0 && Greenfoot.isKeyDown("up"))
        {
            myWorld.setScreen(NorthExit.whichExit());
            setLocation(getWorld().getWidth() / 2,getWorld().getHeight() - 5);
        }
        if (canSee(SouthExit.class) && SouthExit.whichExit() >= 0&& Greenfoot.isKeyDown("down"))
        {
            myWorld.setScreen(SouthExit.whichExit());
            setLocation(getWorld().getWidth() / 2,5);
        }
        if (canSee(EastExit.class) && EastExit.whichExit() >= 0&& Greenfoot.isKeyDown("right"))
        {
            myWorld.setScreen(EastExit.whichExit());
            setLocation(5,getWorld().getHeight() / 2);
        }
        if (canSee(WestExit.class) && WestExit.whichExit() >= 0&& Greenfoot.isKeyDown("left"))
        {

            myWorld.setScreen(WestExit.whichExit());
            setLocation(getWorld().getWidth() - 5,getWorld().getHeight() / 2);
        }
        
        if (canSee(Acorn.class))
        {
            eat(Acorn.class);
            Greenfoot.playSound("bite.wav");
        }
        if (canSee(Mushroom.class))
        {
            eat(Mushroom.class);
            if (!invincible)
            {
                stunned = true;
                speed = -5;
            }
            Greenfoot.playSound("mushroom.wav");
        }
    }

    public void stunTimer()
    {
        stunTimeLeft--;
        if (stunTimeLeft == 0)
        {
            stunned = false;
            speed += 5;
            stunTimeLeft = STUNTIMER;
        }
    }

    public static void isHit()
    {
        invincible = true;
        hitsLeft--;

    }

    public void invincibleTimer()
    {
        invincibleTimeLeft--;
        if (invincibleTimeLeft <= 0)
        {
            invincible = false;
            invincibleTimeLeft = INVINCIBLETIMER;
        }
    }

    public static boolean isInvincible()
    {
        return invincible;
    }

    public static int getHits()
    {
        return hitsLeft;
    }

    public void isDead()
    {}
    public void animate()
    {
        animateCounter++;
        if (animateCounter == 4)
        {
            setImage(image2);
        }
        if (animateCounter == 8)
        {
            setImage(image1);
            animateCounter =  0;
        }
    }



    public void invincibleAnimation()
    {
        animateDelay++;
        if (animateDelay > 3)
        {
            if (getImage() == image4 || getImage() == image1 || getImage() == image2)
            {
                setImage(image3);
            }
            else if (getImage() == image3)
            {
                setImage(image4);
            }
            animateDelay = 0;
        }
    }
}